<script>
import { editColumns, editTabColumns, forbidden, SelectColumns } from "./initColumn";
import orderApi from "@/api/business/purchase/purchase-order";
import {  initDicts, initRules, initParams } from "@/utils/init/index.js";

export default {
  name: "EditPurchaseOrderDrawer",
  dicts: initDicts(SelectColumns),
  components: {
    FileUploadCenter: () => import('../components/FileUploadCenter/index.vue'),
  },
  data() {
    return {
      size: "mini",
      visible: false,
      loading: false,
      columns: editColumns,
      rules: initRules(editColumns),
      params: {
        ...initParams(editColumns),
        puOrderItemList: [],
        puOrderExecuteList: [],
      },

      tabColumns: editTabColumns,
      tabName: "puOrderItemList",
      count:1
    };
  },
  computed: {},
  watch: {
    "params.contractType": function (newProp) {
      this.tabColumns = editTabColumns.filter((element) =>
        newProp === "1" ? element.key !== "puOrderItemList" : element
      );
      this.tabName = this.tabColumns[0].key;
    },
    tabName: function (newProp) {
      const { id } = this.params;
      // this.fetchTable(id, newProp);
    },
    'params.puOrderItemList': {
      handler(nVal, oVal) {
        this.params.source == 3 &&
         this.handleSynchronousMaterial('puOrderItemList', 'puOrderExecuteList');
      },
      deep: true,
      immediate: true
    },
    'params.puOrderExecuteList': {
      handler(nVal, oVal) {
        this.params.source == 3 && 
        this.handleSynchronousMaterial('puOrderExecuteList', 'puOrderItemList');
      },
      deep: true,
      immediate: true
    },
  },
  methods: {
    setVisible(prop) {
      this.visible = prop;

      if(!this.visible){
        this.$refs['orderEditForm'].clearValidate();
      }

    },
    // 同步子表物料
    handleSynchronousMaterial(tableOne, tableTwo) {
      let _this = this;
      // this.params[tableOne]-- -> this.params[tableTwo]
      this.params[tableOne] && this.params[tableOne].length &&

        this.params[tableOne].forEach((item, index) => {

          for (const key in item) {

            if ( _this.params[tableTwo][index] &&
              ( key in _this.params[tableTwo][index])
            ) {

                _this.params[tableTwo][index].material = item.material;

                key !== 'id' && ( _this.params[tableTwo][index][key] = item[key]);

            }
          }
        });
    },
    // 判断属性是否禁用
   async handleIsForbidden(status,source) {
        let { updateColumns, updateTabColumns } = await forbidden(status != '2',source);
        this.columns = updateColumns;
        this.tabColumns = updateTabColumns;
        this.count++;
    },
    // 查询详细
    async fetchItem(prop) {
      try {
        this.loading = true;
        const { code, msg, data } = await orderApi.details(prop);
        if (code === 200) {
          this.params = { ...this.params, ...data };
          this.handleIsForbidden(this.params.status,this.params.source);
        }
      } catch (err) {
        //
      } finally {
        this.loading = false;
      }
    },
    // 新增行
    addTableRow(prop) {

      for (const key in this.params) {

        // if (Array.isArray(this.params[key])) {
        if (key === 'puOrderItemList' || key === 'puOrderExecuteList') {

          const arr = this.tabColumns.find(

            (element) => element['key'] === key

          ).tableColumns;


          let rowData = initParams(arr, "key", "value");

          "rowno" in rowData &&
            (rowData["rowno"] = this.params[key].length + 1);
           // 物料
           if("rowNo" in rowData){

              rowData["rowNo"] = this.params[key].length + 1;
              // 扣税类别
              rowData["taxDeductClassify"] = '1';
              // 价格类型
              rowData["priceType"] = 'order';
              // 币种
              rowData["currency"] = '1002Z0100000000001K1';
              rowData["currencyName"] = '人民币';

            }
          // 是否完成询价，新增明细行需默认明细为false
          rowData['whetherCompleteInquiry'] = false;
          rowData['delFlag'] = '0';

          this.params[key].push(rowData);
        }
      }

      // const arr = this.tabColumns.find(
      //   (element) => element.key === this.tabName
      // ).tableColumns;
      // prop.push(initParams(arr, "key", "value"));
    },
    // 删除行
    async delTableRow(prop, index) {
      // prop.splice(index, 1);
      for (const key in this.params) {

        // if (Array.isArray(this.params[key])) {
        if (key === 'puOrderItemList' || key === 'puOrderExecuteList') {

          this.params[key][index].id ? (this.params[key][index]['delFlag'] = '2') :this.params[key].splice(index, 1);

        }
      }

      await this.handleGetPrice();
    },
    // 取消
    handleCancel() {
      this.params = {
        ...initParams(this.columns),
        puOrderItemList: [],
        puOrderExecuteList: [],
      }
      this.setVisible(false);
    },
    // 判断保存条件
    judgeSaveCondition(cb){
      const _this = this;
      this.$refs['orderEditForm'].validate(async (valid) => {
        if (valid) {

          // 执行结果在审批之后出现 
          let validList = _this.params['puOrderItemList'].filter(item => item.delFlag === '0');
          if(!validList.length ){
            _this.$notify.error({
              title: '错误',
              message: '请填写订单行！'
            });
            
            return false;
          }

          let isPrice =  _this.params.puOrderItemList.filter(item => !item.whetherCompleteInquiry);

         if(isPrice.length){

          _this.$notify.error({
              title: '错误',
              message: '询价失败！'
            });
            return false

         }
         console.log(isPrice,'isPrice');
          cb();

        } else {
          _this.$notify.error({
              title: '错误',
              message: '存在必填项未填写'
            });
          console.log('error submit!!');
          return false;
        }
      });
    },
    // 保存
     handleSava() {
      console.log(this.params,'this.params---------');
      this.judgeSaveCondition(async()=>{
        try {
            this.loading = true;
            const { code, msg } = await (this.handleIsRevise() ?
              orderApi.revision(this.params)
              : orderApi.edit(this.params)
            )
            if (code === 200) {
              this.handleCancel();
            }
          } catch (err) {
            //
          } finally {
            this.loading = false;
          }
      })
    },
    beforeOpen() {
    },

     // 主表参照改变之后
   async handleReferChange(val, type, source){
      // 供应商选择  
      if( type === 'SUPPLIER_PARAM' ){

        let page = { pageNum: 1 , pageSize: 10 };

        let relevanceRefer = [
          {
            // 供应商联系人
            key:'supplierContacts',
            params:{
              type:'SUPPLIERCONTACTS_PARAM',
              supplierId:val.id,
            }
          },
          {
            // 供应商业务员
            key:'supplierPersonal',
            params:{
              type:'PSNLICENSE_PARAM',
              supplierId:val.id,
              pkOrg: source.puOrg,
            }
          }
        ]

        await relevanceRefer.forEach(async (refer) =>{

          try {

            const { code, rows} = await orderApi.REFER(
              {
                ...refer.params,
                search: "",
                isPage: true,
              }, page );

            if (code === 200) {

              source[refer.key] = rows[0]? rows[0].id :'';

              source[`${refer.key}Name`] = rows[0] ? rows[0].name :'';

            }
            
          } catch (error) {}
          
        })

        // 明细不为空的情况下进行询价
        let detailList = this.params['puOrderItemList'].filter(item => (
          item.material && item.material != '' 
        ))
        
        if(detailList.length){

          this.params['puOrderItemList'] = this.params['puOrderItemList'].map(item => {

            item['whetherCompleteInquiry'] = false

            return item;
          });

          await this.handleGetPrice();
        }
      }
    },
    // 子表参照改变之后
    async handleTabReferChange(val, type, source) {

      // 触发物料参照
      if (type == "MATERIAL_PARAM" && source.qty && source.qty != "") {

        source['qty'] = 0;

        source['whetherCompleteInquiry'] = false;
        
        source['taxPrice'] = 0;

        source['money'] = 0;

        source['taxDeductMoneya'] = 0;

        source['price'] = 0;
        
        source['notaxMoney'] = 0;
        
        source['tax'] = 0;

        this.params['qty'] = 0;
        this.params['originalQty'] = 0;
        this.params['money'] = 0;
        this.params['originalMoney'] = 0;
        this.params['notaxMoney'] = 0;

        source.isDrug = val.materialMedcine.isDrug  == '0' ? 'Y' : 'N';
        
        // await this.handleGetPrice();

      }

    },

    // 子表Select改变之后
     handleSelectChange(val,typeName){

      if(val === 'billType'){

       this.params['billTypeName'] = this.dict.type[typeName].find(item => item.value == this.params[val]).label;
      
      }

    },

     // 子表下拉框改变
     handleTabSelectChange(type,row){
 
      // && row.qty
      if(type == 'priceType' && row.material  && row.qty != ""){

        row['whetherCompleteInquiry'] = false;

        this.handleGetPrice();

      }
    },
    // 子表inputNumber
    handleInputChange(row, type) {


      // 物料数量变化----询价
      if (type == 'qty' && row.material ) {

        if(this.params.status === '2'){

          // 修订
          this.handleCalculateOrderAmount();

        }else{

          row['whetherCompleteInquiry'] = false;

          row.qty && this.handleGetPrice();

        }

      }

      // // 物料数量变化----询价
      // if (type == 'qty' && row.material) {

      //   row['whetherCompleteInquiry'] = false;

      //   // row.qty && this.handleGetPrice();
      //   this.handleGetPrice();

      // }

    },
    // 子表多选框改变
    handleTabCheckbox(type,source){

      // 勾选赠品，价税合计更新为0，含税单价、无税单价更新为0
      if(type === 'isGift' && source.material && source.qty && source.qty != ""){

        source['whetherCompleteInquiry'] = false;

        this.handleGetPrice()
      }

    },
    // 询价 getPrice
    async handleGetPrice() {
      try {
        // action:insert(新增)、revise(修订)、update(编辑)
        let { code, data } = await orderApi.getPrice({
          ...this.params ,
          action: this.handleIsRevise() ? 'revise':'update',
        });
        if (code == 200) {
          this.params = data;
        }
      } catch (error) {

      } finally {

      }
    },
    // 修订——计算金额
    async handleCalculateOrderAmount(){

      try {
        let { code, data } = await orderApi.calculateOrderAmount({ 
          ...this.params,
          action: this.handleIsRevise() ? 'revise':'update',
        });
        
          code == 200 &&  (this.params = data);

      } catch (error) {} 
      finally {}

    },

    // 判断修订还是编辑
    handleIsRevise() {
      return this.params.status == '2';
    },

    // /handleIsRevise() ? scope.row[cColumn.key] : Infinity
    getInputNumberMax(key,row){

      if(key === 'qty'){

        return this.handleIsRevise() ? row['originalQty'] : Infinity
      
      }

      return Infinity;
    },
  },
  created() {},
  mounted() { },
  destroyed() { },
};
</script>
<template>
  <el-drawer 
    direction="btt" 
    size="100%" 
    :with-header="false" 
    :visible.sync="visible" 
    @open="beforeOpen"
    @close="$emit('close')"
    >
    <el-form 
      :key="count"
      v-loading="loading" 
      :size="size" 
      ref="orderEditForm" 
      label-position="right" 
      label-width="140px"
      :model="params" 
      :rules="rules"
      >
      <el-card :body-style="{
        padding: '20px',
        display: 'flex',
        'flex-wrap': 'wrap',
      }" style="margin: 10px">
        <div slot="header" style="
            display: flex;
            justify-content: space-between;
            align-items: center;
          ">
          <h3>{{ handleIsRevise() ? '修订' : '编辑' }}</h3>
          <div style="text-align: right">
            <el-button :size="size" type="primary" @click="handleSava">更 新</el-button>
            <el-button :size="size" @click="handleCancel">取 消</el-button>
          </div>
        </div>
        <el-row style="display:flex; flex-wrap: wrap;">
          <el-col 
            v-for="(column, index) in columns" 
            :key="index" 
            :span="column.span || 6"
            >
            <el-form-item :prop="column.key" :label="column.title" v-if="column.isShow">

              <el-input v-if="column.inputType === 'Input'" 
                v-model="params[column.key]" 
                :placeholder="column.placeholder"
                :clearable="column.clearable" 
                :disabled="column.disabled" 
                style="width: 100%"
                ></el-input>
              <dr-popover-select v-if="column.inputType === 'PopoverSelect'" 
                v-model="params[column.key]" 
                size="mini"
                :value-key="column.valueKey" 
                :source.sync="params" 
                :title="column.title" 
                :type="column.referName"
                :multiple="column.multiple" 
                :placeholder="column.placeholder" 
                :data-mapping="column.dataMapping"
                :disabled="column.disabled" 
                :query-params="column.queryParams"
                @change="handleReferChange"
                ></dr-popover-select>
              <el-input v-if="column.inputType === 'Textarea'" 
                v-model="params[column.key]" 
                type="textarea"
                :placeholder="column.placeholder" 
                :clearable="column.clearable" 
                :disabled="column.disabled"
                style="width: 100%"
                ></el-input>
              <el-input-number v-if="column.inputType === 'InputNumber'" 
                v-model="params[column.key]"
                :precision="column.precision"
                :max="handleIsRevise() ? params[column.key] : Infinity"
                :controls-position="column.controlsPosition" 
                :placeholder="column.placeholder"
                :clearable="column.clearable" 
                :disabled="column.disabled" 
                style="width: 100%"
                ></el-input-number>
              <el-select v-if="column.inputType === 'Select'" 
                v-model="params[column.key]" 
                :disabled="column.disabled"
                :clearable="column.clearable" 
                :placeholder="column.placeholder" 
                style="width: 100%"
                @change="handleSelectChange(column.key,column.referName)"
                >
                <el-option 
                  v-for="item in dict.type[column.referName]" 
                  :key="item.value" 
                  :label="item.label"
                  :value="item.value"
                  ></el-option>
              </el-select>
              <el-select v-if="column.inputType === 'TagSelect'" 
                v-model="params[column.key]" 
                multiple 
                clearable
                collapse-tags 
                :placeholder="column.placeholder" 
                :clearable="column.clearable" 
                :disabled="column.disabled"
                style="width: 100%"
                >
                <template #prefix>
                  <el-icon class="el-icon-view" style="cursor: pointer" @click.stop="$message.info(234)"></el-icon>
                </template>
                <el-option 
                  v-for="item in options" 
                  :key="item.value" 
                  :label="item.label" 
                  :value="item.value"
                  ></el-option>
              </el-select>
              <el-date-picker v-if="column.inputType === 'DatePicker'" 
                v-model="params[column.key]" 
                :type="column.type"
                :placeholder="column.placeholder" 
                :clearable="column.clearable" 
                :disabled="column.disabled"
                :picker-options="column.pickerOptions" 
                style="width: 100%"
                ></el-date-picker>
              <el-checkbox v-if="column.inputType === 'Checkbox'" 
                v-model="params[column.key]" 
                :disabled="column.disabled"
                true-label="Y"
                false-label="N"
                > </el-checkbox>
              <file-upload-center v-if="column.inputType === 'Upload'" 
                v-model="params[column.key]"
                :file-type="column.fileType" 
                :disabled="handleIsRevise()"
                ></file-upload-center>
            </el-form-item>
          </el-col>
        </el-row>
      </el-card>
      <el-card :body-style="{
        padding: '20px',
        display: 'flex',
        'flex-wrap': 'wrap',
        position: 'relative',
      }" style="margin: 10px">
        <el-tabs v-model="tabName" style="width: 100%">
          <el-tab-pane 
            v-for="(column, index) in tabColumns" 
            :key="index" 
            :label="column.title" 
            :name="column.key"
            >
            <el-table 
              border
              :data="params[column.key].filter(item => item.delFlag === '0')" 
              style="width: 100%"
              :height="params[column.key].filter(item => item.delFlag === '0').length ? 300 : 100"
            >
              <el-table-column label="序号">
                <template slot-scope="scope">
                  {{ scope.$index + 1 }}
                </template>
              </el-table-column>
              <el-table-column 
                v-for="(cColumn, cIndex) in column.tableColumns" 
                :key="cIndex" 
                :prop="cColumn.key"
                :label="cColumn.title" 
                :width="cColumn.width"
                >
                <template slot="header" slot-scope="scope">
                  <span v-if="cColumn.require" style="color: #ff4949">*</span>
                  <span>
                    {{ cColumn.title }}
                  </span>
                </template>
                <template slot-scope="scope">

                  <el-form-item 
                    label-width="0" 
                    :prop="`${column.key}.${scope.$index}.${[cColumn.key]}`"
                    :rules="{ required: cColumn.require || false, message: `${cColumn.title}不能为空`, trigger: 'change' }"
                  >

                  <span v-if="!cColumn.inputType">
                    {{ scope.row[cColumn.key] }}
                  </span>

                  <el-input v-if="cColumn.inputType === 'Input'" 
                    v-model="scope.row[cColumn.key]"
                    :placeholder="cColumn.placeholder" 
                    :clearable="cColumn.clearable" 
                    :disabled="cColumn.disabled"
                    :size="size" 
                    style="width: 100%"
                    ></el-input>

                  <dr-popover-select v-if="cColumn.inputType === 'PopoverSelect'" 
                    v-model="scope.row[cColumn.key]"
                    :source.sync="scope.row" 
                    :title="cColumn.title" 
                    :value-key="cColumn.valueKey"
                    :disabled="cColumn.disabled" 
                    :type="cColumn.referName" 
                    :multiple="cColumn.multiple"
                    :placeholder="cColumn.placeholder" 
                    :data-mapping="cColumn.dataMapping"
                    :query-params="cColumn.queryParams" 
                    size="mini" 
                    @change="handleTabReferChange"
                  ></dr-popover-select>

                  <el-select v-if="cColumn.inputType === 'Select'" 
                    v-model="scope.row[cColumn.key]" size="mini"
                    :disabled="cColumn.disabled" 
                    :clearable="cColumn.clearable" 
                    :placeholder="cColumn.placeholder"
                    style="width: 100%"
                    @change="handleTabSelectChange(cColumn.key,scope.row)"
                  >
                    <el-option 
                      v-for="item in dict.type[cColumn.referName]" 
                      :key="item.value" 
                      :label="item.label"
                      :value="item.value"
                    ></el-option>
                  </el-select>

                  <el-checkbox v-if="cColumn.inputType === 'Checkbox'" 
                    v-model="scope.row[cColumn.key]"
                    :disabled="cColumn.disabled" 
                    true-label="Y" 
                    false-label="N"
                    @change="handleTabCheckbox(cColumn.key,scope.row)"
                  ></el-checkbox>
                  <el-input-number v-if="cColumn.inputType === 'InputNumber'" 
                    v-model="scope.row[cColumn.key]"
                    :precision="cColumn.precision"
                    :controls-position="cColumn.controlsPosition"
                    :max="getInputNumberMax(cColumn.key, scope.row)"
                    @change="handleInputChange(scope.row, cColumn.key)" 
                    :placeholder="cColumn.placeholder"
                    :clearable="cColumn.clearable" 
                    :disabled="cColumn.disabled" 
                    :size="size" 
                    style="width: 100%"
                  ></el-input-number>

                </el-form-item>
                </template>
              </el-table-column>


              <!-- 修订：不可删除、增行
              编辑：自制：可删可增 -->
              <el-table-column fixed="right" label="操作" width="120">
                <template slot-scope="scope">
                  <el-button 
                    v-if="params.source == '3' && !handleIsRevise()" 
                    @click.native.prevent="delTableRow(params[tabName], scope.$index)" 
                    type="text" 
                    size="small"
                    > 删行
                  </el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-tab-pane>
        </el-tabs>
        <el-row style="position: absolute; top: 20px; right: 20px">
          <el-button v-if="params.source == '3' && !handleIsRevise()" :size="size"
            @click="addTableRow(params[tabName])">增行</el-button>
        </el-row>
      </el-card>
    </el-form>
  </el-drawer> 
</template>
